VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form frmSubscriberSearch 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Subscriber Search"
   ClientHeight    =   5850
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7725
   ControlBox      =   0   'False
   Icon            =   "frmSubscriberSearch.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5850
   ScaleWidth      =   7725
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid myGrid 
      Height          =   3975
      Left            =   60
      TabIndex        =   9
      Top             =   1860
      Width           =   7635
      _ExtentX        =   13467
      _ExtentY        =   7011
      _Version        =   393216
      Cols            =   1
      FixedCols       =   0
      AllowBigSelection=   0   'False
      SelectionMode   =   1
      AllowUserResizing=   1
      RowSizingMode   =   1
      _NumberOfBands  =   1
      _Band(0).Cols   =   1
   End
   Begin VB.Frame Frame1 
      Caption         =   "Search By"
      Height          =   1575
      Left            =   60
      TabIndex        =   2
      Top             =   120
      Width           =   5895
      Begin VB.CommandButton cmdSearch 
         Caption         =   "Search"
         Height          =   375
         Left            =   4770
         TabIndex        =   8
         Top             =   1140
         Width           =   1065
      End
      Begin VB.TextBox txtSearchString 
         Height          =   285
         Left            =   2160
         TabIndex        =   7
         Text            =   "*"
         Top             =   360
         Width           =   3675
      End
      Begin VB.OptionButton optSearchByExtension 
         Caption         =   "Extension"
         Height          =   195
         Left            =   240
         TabIndex        =   6
         Top             =   1200
         Width           =   2265
      End
      Begin VB.OptionButton optSearchByAlias 
         Caption         =   "Alias"
         Height          =   195
         Left            =   240
         TabIndex        =   5
         Top             =   920
         Width           =   1965
      End
      Begin VB.OptionButton optSearchByLastName 
         Caption         =   "Last Name"
         Height          =   195
         Left            =   240
         TabIndex        =   4
         Top             =   640
         Value           =   -1  'True
         Width           =   1875
      End
      Begin VB.OptionButton optSearchByFirstName 
         Caption         =   "First Name"
         Height          =   195
         Left            =   240
         TabIndex        =   3
         Top             =   360
         Width           =   1845
      End
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   6570
      TabIndex        =   1
      Top             =   1290
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   6570
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmSubscriberSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'This form is used to allow users to select a subscribers from among all the mail users
'on the local Unity server.  They can filter based on first/last name, alias or extension and the
'results will be displayed in a grid they can then sort and shuffle around to find the guy they
'want.

'To make this application portable I'm forced to use one of the built in grids that ships with VB 6.
'The best of the bunch is the FlexGrid but it's not all that hot - just about any 3rd party grid you
'randomly pull out of your hat is going to be better than this but at least it lets us bind a recordset
'to the grid on the fly - I'm not going to put a bunch of time into doing the code to sort by column
'header clicks and resize coumns automatically and all that (things that come for free with any decent
'grid control) - this is just to show you how all this works, not make a nifty UI...

'Basically I just create a big, gnarly SQL select statement based on the user's search request,
'populate a temporary recordset object with it and bind it to a grid.  It works pretty quick even
'for large result sets.  One possible problem, I suppose, is the grid I think caps out at around
'250,000 rows... I suppose eventually that may be a problem.

'The calling party checks these two public variables here to see if the user picked a subscriber and if
'so snag it's alias. You could also pass around it's objectID here and avoid having to look it up again
'later but we're keeping things simple here.
Public strAlias As String
Public strObjectID As String
Public bCancelHit As Boolean

'temporary recordset used to store the subscriber's that meet the search criteria
Dim tempRSSubscribers As New ADODB.Recordset

'At form load time position it in the upper left and clear the two public variables checked by the calling party.
Private Sub Form_Load()
    
    Me.Left = 200
    Me.Top = 200
    
    'Set all the public varriables
    bCancelHit = False
    strAlias = vbNullString
End Sub

'When the user hits the search button, construct the appropriate SQL query, apply it to the temporary recordset and bind it to
'the grid control.
Private Sub cmdSearch_Click()
Dim strSQL As String

    On Error Resume Next
    tempRSSubscribers.Close
    On Error GoTo ErrorHandling
    Me.MousePointer = vbHourglass
    
    'Setup start of SQL string to get the subscriber and call handler information into the recordset.
    'well get the WHERE clause setup based on user selection on the form.
    strSQL = "SELECT vw_Subscriber.Alias, vw_Subscriber.DisplayName,vw_CallHandler.DtmfAccessId, vw_Subscriber.FirstName,vw_Subscriber.LastName, vw_Subscriber.SubscriberObjectID " + _
        "FROM vw_CallHandler INNER JOIN vw_Subscriber ON " + _
        "vw_CallHandler.CallHandlerObjectId = vw_Subscriber.CallHandlerObjectId " + _
        "WHERE (vw_Subscriber.SubscriberType IN (1,3))"
    'Limit the return list based on the search string text.
    If Left(txtSearchString.Text, 1) = "*" Then
        'get all records
    Else
        'First, replace any "*" character with "%" since SQL uses this as it's wildcard character
        If optSearchByFirstName.Value Then
            strSQL = strSQL + "AND (Subscriber.FirstName LIKE '" + txtSearchString.Text + "') "
        ElseIf optSearchByLastName.Value Then
            strSQL = strSQL + "AND (Subscriber.LastName LIKE '" + txtSearchString.Text + "') "
        ElseIf optSearchByAlias.Value Then
            strSQL = strSQL + "AND (Subscriber.Alias LIKE '" + txtSearchString.Text + "') "
        Else ' search by Extension
            strSQL = strSQL + "AND (CallHandler.DTMFAccessID LIKE '" + txtSearchString.Text + "') "
        End If
    End If
    
    'tack on "group by" clause so duplicates don't show up.
    strSQL = strSQL + "GROUP BY vw_Subscriber.Alias, vw_Subscriber.DisplayName, vw_CallHandler.DtmfAccessId, vw_Subscriber.FirstName,vw_Subscriber.LastName, vw_Subscriber.SubscriberObjectID"
    strSQL = Replace(strSQL, "*", "%")
    
    'Normally I'd use a forward only/read only record set here (called a "Firehose cursor") for speed.  However the lame grid controls
    'that ship with VB need either a dynamic or keyset recordset so we'll have to use those.  For the purposes of this little demo
    'that's fine - for a production applications I'd highly reccomend getting hold of a decent 3rd party grid and using that for this
    'type of thing.
    tempRSSubscribers.Open strSQL, strConnectionString, adOpenKeyset, adLockReadOnly
    Set myGrid.DataSource = tempRSSubscribers
    DoEvents
    
    Me.MousePointer = vbDefault
    Exit Sub
ErrorHandling:
    Debug.Assert False
    Resume Next
End Sub

'when the user bails out, close up shop.
Private Sub cmdCancel_Click()
    bCancelHit = True
    myFinalExit
End Sub

Private Sub cmdOK_Click()
    
    'the built in grid that ships with VB is really weak - so we have to make this check to see if a subscriber
    'is actually selected here - again, a decent 3rd party grid control gives you nicer options than this
    On Error GoTo cmdOK_Click_Error

    If Len(myGrid.TextMatrix(myGrid.Row, 0)) = 0 Then
        MsgBox "You must select a subscriber first"
        Exit Sub
    End If
    
    bCancelHit = False
    
    'the alias is stroed in the first column which is column #0 and the objectId is stored in column #5 here
    strAlias = myGrid.TextMatrix(myGrid.Row, 0)
    strObjectID = myGrid.TextMatrix(myGrid.Row, 5)
        
    'close up shop
    myFinalExit

    Exit Sub
cmdOK_Click_Error:
    MsgBox "(error):" & Err.Number & " (" & Err.Description & ") in procedure cmdOK_Click of Form frmSubscriberSearch"
    Debug.Assert False
    Resume Next
End Sub

'when exiting the form clean up shop
Private Sub myFinalExit()
    On Error Resume Next
    tempRSSubscribers.Close
    Set tempRSSubscribers = Nothing
    Unload Me
End Sub

